//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//---------------   GSM  M95   STM32F10XX ------------------
//--           --
//- :          -
//----  :   yagov@promelec.ru  support@promelec.ru -----
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
//--------------     M95 -------------------
//--------------   ,      --------------------
//------------------------------------------------------------------------------

#include "M95_Drive.h"

uint32_t A;

ErrorStatus Compare_Rx_Buffer(Message_TypeDef* B)
{
//    (  START_RX_Pointer -   
//    RX_Buffer)
uint16_t I;
uint16_t J;
char Q;
//        = true
//    B.LEN
//   1  , ..    " "
for (I=0; I<=B->LEN; I++)
{
//     
if ((START_RX_Pointer+I)<((int16_t)(RX_Buffer_Size))) Q=(char)(RX_Buffer[START_RX_Pointer+I]);
//     -    
else Q=(char)(RX_Buffer[START_RX_Pointer+I-RX_Buffer_Size]);
//         -       SUCCESS
//     -  "ERROR"
//   - - ,
//    -  (0x20) "," (2C),     
//     .  SUCCESS.
//   , ,   SMS.  -  ,   -   ().
if ((((Q==0xa)||(Q==0xd))||(((Q==0x20)||(Q==0x2C))&&(I==B->LEN)))&&(I>=2))
{
J=0;
Q=(char)(RX_Buffer[START_RX_Pointer]);
  while (Q!=0xa)
  {
   //RX_Buffer[START_RX_Pointer] = 0xa;   //  
   START_RX_Pointer++;
   J++;
   //       
   if (START_RX_Pointer>=RX_Buffer_Size) START_RX_Pointer=0;
   //   Q
   Q=(char)(RX_Buffer[START_RX_Pointer]);
   if (((Q==0x20)||(Q==0x2C))&&(J==B->LEN)) Q=0xa;
  }
  //        =    0xd
  //  
   START_RX_Pointer++;
   //       
   if (START_RX_Pointer>=RX_Buffer_Size) START_RX_Pointer=0;

  return (SUCCESS);
}
//        ERROR
if (Q!=((char)(*(B->TEXT+I)))) return (ERROR);
}

return (ERROR);
}

void Copy_Rx_Buffer (Message_TypeDef* B)
{
//  RX    START_RX_Pointer     
//   
char Q;
Q=0;
  //     - 
  while (Q!=0xa)
  {
    //  
    Q=(char)(RX_Buffer[START_RX_Pointer]);
    //  
    B->TEXT[B->LEN]=Q;
    B->LEN++;
    //            
   START_RX_Pointer++;
   //       
   if (START_RX_Pointer>=RX_Buffer_Size) START_RX_Pointer=0;
  }  
}

void Copy_Rx_Nomber (Message_TypeDef* B)
{
//    RX    START_RX_Pointer     
//   
char Q;
uint8_t Flag;
Q=0;
Flag=0;
  //     - 
  //   " "   "+" - ,    ,
  //    (    "+") -  
  //     " " -  
  while (Q!=0xa)
  {
    //  
    Q=(char)(RX_Buffer[START_RX_Pointer]);
    
    //     
    if (((Q>=0x30)&&(Q<=0x39))||(Q=='+')||(Q=='"'))
    {
    Flag=1;
    //  
    B->TEXT[B->LEN]=Q;
    B->LEN++;
    }
    else
      //   
      if (Flag==1) Q=0xa;
      
    //            
   START_RX_Pointer++;
   //       
   if (START_RX_Pointer>=RX_Buffer_Size) START_RX_Pointer=0;
  }  
}


void CopyString(Message_TypeDef *A, Message_TypeDef* B)
//   B   
// A -    
// B -    (     , ,   )
// B -    : 1-  -     
{
uint32_t I;
//  
for (I=0; I<B->LEN; I++)
{
A->TEXT[A->LEN] = B->TEXT[I];
A->LEN++;
}

}


void Built_Test(Message_TypeDef* A, Message_TypeDef* B)
//    
// A -    
// B -    (     , ,   )
//   : AT+<x>=? (    )
// x -   B,    ,   B
// B -    : 1  -       ( )
{
A->LEN = 0;
CopyString(A, &message_AT_PLUS);
CopyString(A, B);
CopyString(A, &message_Built_Test);
}

void Built_Read(Message_TypeDef* A, Message_TypeDef* B)
//    
// A -    
// B -    (     , ,   )
//   : AT+<x>? (    )
// x -   B,    ,   B
// B -    : 1  -       ( )
{
A->LEN=0;
CopyString(A, &message_AT_PLUS);
CopyString(A, B);
CopyString(A, &message_Built_Read);
}

void Built_Write(Message_TypeDef* A, Message_TypeDef* B, Message_TypeDef* C)
//     
// A -    
// B -    (     , ,   )
// C -    
//   : AT+<x>=<y> (    )
// x -   B,    ,   B
// y -   C,    ,   C
// B -    : 1  -       ( )
// C -    : 1  -       ( )
{
A->LEN=0;
CopyString(A,&message_AT_PLUS);
CopyString(A,B);
A->TEXT[A->LEN]='=';
A->LEN++;
CopyString(A,C);
CopyString(A,&message_Built_Write);

}


void Built_Execute(Message_TypeDef* A, Message_TypeDef* B)
//    
// A -    
// B -    (     , ,   )
//   : AT+<x> (    )
// x -   B,    ,   B
// B -    : 1  -       ( )
{
A->LEN=0;
CopyString(A, &message_AT_PLUS);
CopyString(A,B);
A->TEXT[A->LEN]=0xd;
A->TEXT[A->LEN+1] = 0xa;                      //    (M95 -  ,   )
A->LEN +=2;
}

void Built_Message (Message_TypeDef* A, Message_TypeDef* B)
//    
// A -    
// B -    (     , ,   )
//   : <x> (    )
// x -   B,    ,   B
// B -    : 1  -       ( )
{
A->LEN=0;
CopyString(A,B);
A->TEXT[A->LEN]=0xd;
A->TEXT[A->LEN+1] = 0xa;                      //    (M95 -  ,   )
A->LEN +=2;  
}

void Built_Answer (Message_TypeDef* A, Message_TypeDef* B)
//        ()    
// A -    
// B -    (     , ,   )
//   : <x> (    )
// x -   B,    ,   B
// B -    : 1  -       ( )
{
A->LEN=0;
CopyString(A,&message_AT_PLUS);
CopyString(A,B);
A->TEXT[A->LEN]=(uint8_t)('='); //   '='
A->LEN++;
Copy_Rx_Buffer(A); //     ,   0xd, 0xa
}





uint32_t ADDR_FUNC;             //       ProcessMashine ()
                                //             Jump_Addr, 
                                //  ASM ( Help.asm)
extern void Jump_Addr (void);   //     ,      Jump_Addr
                                //    ASM ,       ( Help.asm)

void ProcessMashine(void)
//  
//   
//   
//      =   
//      
{
uint8_t FLAG;
uint8_t FLAG1;
uint8_t I;
//char* A;
Message_TypeDef* B;

//    ,     
while (START_RX_Pointer!=STOP_RX_Pointer)
{
FLAG = 0;
FLAG1 = 0;
I = 0;
while ((I<ProceesMashine_Buffer.LEN)&&(FLAG==0))
{
  //      ,  
  B = (Message_TypeDef*) (*((uint32_t*)(ProceesMashine_Buffer.Messages)+I));

    if (Compare_Rx_Buffer(B)==SUCCESS)
    {
      //      
      FLAG = 1;
      FLAG1 = 1;
      //    
      ADDR_FUNC = (uint32_t)(*(uint32_t*)(ProceesMashine_Buffer.Functions+(I*sizeof(uint32_t*))));
      //    ,      ADDR_FUNC
      Jump_Addr();
    }
  I++;

}
//       ,      :
if (FLAG1==0) 
//     ,   
//    
  {
  char Q;
  Q=(char)(RX_Buffer[START_RX_Pointer]);
  while (Q!=0xa)
  {
   //RX_Buffer[START_RX_Pointer] = 0xa;
   START_RX_Pointer++;
   //       
   if (START_RX_Pointer>=RX_Buffer_Size) START_RX_Pointer=0;
   //   Q
   Q=(char)(RX_Buffer[START_RX_Pointer]);
  }
  //        =    0xd
  //  
   START_RX_Pointer++;
   //       
   if (START_RX_Pointer>=RX_Buffer_Size) START_RX_Pointer=0;
  }
}
}

void State_Mishine_Copy(uint8_t NewState)
//    (     )
{
ProceesMashine_Buffer.LEN = (uint32_t) *((uint32_t*) ((uint32_t) Stages[NewState]));
ProceesMashine_Buffer.Messages = (uint32_t)((((uint32_t*) ((uint32_t) Stages[NewState])))+1);
ProceesMashine_Buffer.Functions = ProceesMashine_Buffer.Messages + (ProceesMashine_Buffer.LEN * sizeof(uint32_t*));
}

void Echo_Ok (void)
{
//      ( )
  SYSTIC_Stop();                                                        // 
  Echo_Correct_Flag=0;
}


//------------------------------------------------------------------------------
//---------------   GSM  M95   STM32F10XX ------------------
//--------------------------           2013         ----------------------------
//------------------------------------------------------------------------------
